\d .tt

/ F=initial or drilldown function, Z = table attribute dict, X = by-table attribute dict, Y = global attribute dict, V = ` or previous treetable, U = underlying table, R = required, S = selected
/ z = updated attribute dict, v = calculated treetable, w = datatable, w_ = systemtable (construct_ does not modify X)
construct_:{[F;X;Y;Z;R;U;V]
 q:treetable_[F;X;Y;Z;R;U]V;Z:q 0;v:q 1;r:q 2;
 q:subtreetable[Y;Z]v;w:q 0;w_:q 1;
 (Z;v;r;w;w_)}

/ return a subtreetable = W W_
subtreetable:{[Y;Z;v]
 z:Z Y`tab;
 r:rows[z]1_v;
 w:row0[z;v]datacolumns[z]r;
 w_:row0[z;v]systemcolumns[z]r;
 (w;w_)}

/ build just the treetable = Z V
treetable_:{[F;X;Y;Z;R;U;V]
 q:xyz[X;Y]Z;x:q 0;z:q 1;
 G_::g:z`groups;N_::0#`;
 v:0!setselection[U;keys U]z`selected;
 v:update i_:1 from v;
 a:parserollups[v]x`rollups;
 r:required[R;z;x;v;g]a;
 v:?[v;();0b;r!r];
 v:filter[v]. z`filters`filtering`filters_not`filters_or;
 v:setranks[v;a]z`ranks;
 v:symbolize[v]g;
 v:F[v;g;a;z`paths;V]z`paths_;
 z[`paths_]:z`paths;
 v:setsorts[v;g]x`sortseqs;
 v:setlevels v;
 v:transform[v;g]x`transforms;
 v:sort[v;g]. z[`sorting`sorts],x 1#`sortseqs;
 Z[Y`tab]:z;
 (Z;v;r)}

/ split and preprocess X, Y, Z -> x, y, z
xyz:{[X;Y;Z]z:Z Y`tab;x:X z`table;z[`paths]:paths[z`groups]z`paths;(x;z)}

/ entry points
treetable:{[X;Y;Z;R;U;V]treetable_[rollups;X;Y;Z;R;U]`}
construct:{[X;Y;Z;R;U]construct_[rollups;X;Y;Z;R;U]`}
reconstruct:{[X;Y;Z;R;U;V]construct_[drill;X;Y;Z;R;U]V}

/ set/get timestamp
setz:{[X;Y;Z;z].[X;(table[Y]Z;`updatez);:;z]}
getz:{[X;Y;Z]X[table[Y]Z;`updatez]}

/ set/get #updates
setn:{[X;Y;Z;z].[X;(table[Y]Z;`updaten);:;z]}
getn:{[X;Y;Z]X[table[Y]Z;`updaten]}

/ eliminate invalid paths after group change
paths:{[g;p]1!$[count g;(0!p)where g paths_/:key each exec n from p;1#0!p]}
paths_:{[g;n]m:count[g]&count n;(m#n)~m#g}

/ properties
setproperties:{}
getproperties:{[X;Y;Z;U;V;W]
 d:((`tabs	;key Z);
    (`tab	;Y`tab);
    (`fixedcols	;count Z[Y`tab]`fixedcols);
    (`sources	;sources_ Y`linktree);
    (`count	;count V);
    (`groups	;Z[Y`tab]`groups);
    (`root	;Z[Y`tab]`root);
    (`rows	;`start`end!rows_[W 0]. get Z[Y`tab]`rows);
    (`table	;table[Y]Z);
    (`updatez	;getz[X;Y]Z);
    (`updaten	;getn[X;Y]Z);
    (`sorts	;Z[Y`tab]`sorts));
 (!). flip d}

/ metadata where column is visible
visiblecols:{[X;Y;Z;W]select from X[table[Y]Z]`cols where col in cols W 0}

/ table of currrent tab
table:{[Y;Z]Z[Y`tab]`table}

/ block of rows
rows:{[z;v]take[v]. z[`rows]`start`end}
take:{[v;s;e]$[s>=count v;0#v;((1+e-s)&count z)#z:s _ v]}
rows_:{[v;s;e]s,e&s+-1+count v}

/ (1_treetable;grandtotal row)
row0:{[z;v;r](r;?[v;enlist(=;`i;0);0b;q!q:cols r])}

/ visible, ordered, cleaned
datacolumns:{[z;v]f:z`fixedcols;r:columns[v]f,z[`columns]except f;$[`h_ in f;cleancolumns[$[z`counts;groupcolumns v`i_;::]]r;r]}
cleancolumns:{[f;v]$[7=type v`h_;@[v;`h_;:;`];f update h_:`${(1+x?"}")_x}each string h_ from(update h_:{@[x;where -7=type each x;:;`]}h_ from v)where h_ like"{*"]}
systemcolumns:{[z;v]columns[v]key[Systemcolumns]except`h_}
groupcolumns:{[i_;v]h:v`h_;i:where -7<>type each h;h[i]:`${x,"[",y,"]"}'[string h i;string i_ i];v[`h_]:h;v}
columns:{[v;c]?[v;();0b;c!c]}

/ filter
filter:{[d;f;b;n;o]if[(0=count f)|not b;:d];i:til count d;d filternot[n;i]$[not o;filter_[d]/[i;key f;get f];distinct raze filter_[d;i]'[key f;get f]]}
filternot:{[n;i;j]til[0],$[n;i except j;j]}
filter_:{[x;y;z;w]y where matches[(0!x)[y;z];w]}
Matchable:1 5 6 7 8 11 13 14 15 16 17 18 19h
matchable:{$[(t:type x)in Matchable;t;0h]}
ismatchable:{0h<>matchable x}
ifstring:{$[10h=type x;x;string x]}
matches:{$[isfunction y;pattern[x;y];t:matchable y;$[t=type x;x in y;count[x]#1b];"{"=first y;pattern[x;@[value;y;{{x=x}}]];issymbols x;x like y;isatom y;x=type[first x]$ifstring y;count[x]#0b]}
pattern:{$[1h=type r:@[y;x;()];r;x=x]}

/ restriction
restrict:{[X;Y;Z;U]restrict_[X[table[Y]Z]`cols;U;invert Y`linktree;Y[`restrict]0]Y`tab}
restrict_:{[c;t;k;r;s]$[count r:restrictby[restrictions[NA]r]1_restrictchain[k]s;restrictsyms[c;t]r;t]}
restrictsyms:{[c;t;r]?[t;({(=;x;$[-11h=type y;enlist y;y])}').{(y;unsymbolize[x;y;z])}[c].(0!r)`col`sym;0b;()]}
restrictby:{[a;b]restricted select from a where source in b}
restrictchain:{[k;s]s,$[count i:where s=k`target;distinct raze .z.s[k]each k[i]`source;0#`]}
restrictions:{[k;r]update sym:` from(select from reverse r where i in col?distinct col)where sym=k}
restricted:{[r]if[count z:select from r;r:r except z;while[0<count s:select from r where target in z`source;z,:s;r:r except s]];z}
unsymbolize:{[c;g;d]e:count[g]#d;f:count[g]_d;unsymbolize_[c]'[g;e],f}
unsymbolize_:{[c;g;d]$["s"=c[g;`qtype];d;first[string upper t]$string d]}

/ linking
Conjoin:0b
Direction:0b
Expandto:0

navigate:{[X;Y;Z;V;r;c]
 s:Y`tab;w:Z s;g:w`groups;
 if[count[g]<count n:(V`n_)r;n:count[g]#n];
 if[b:`h_=c;m:n;c:count[m]#g];
 if[not b;m:V[r;c];if[null m;:Y];m:`$string m];
 k:invert Y`linktree;
 t:first 1_distinct raze targets[k]s;
 navigate_[X;Y;k;s;t;c]m}

navigate_:{[X;Y;k;s;t;c;m]
 k0:Y[`restrict]0;
 k1:Y[`restrict]1;
 i:k0[`source]?s;
 a:flip`col`sym`source`target!2 flip/count[c]#/:(c;m;s;t);
 k2:(i#k0),a;
 if[Direction&not Conjoin;
  if[1<count k2;
   k2:delete from k2 where source in sources[delete from k2 where target=t,source=s;t]]];
 Y[`restrict]:(k2;0#k1);
 Y[`tab]:t;
 Y}

invert:{[k]$[Direction;([]source:k`target;target:k`source);k]}
targets:{[k;s]s,$[count t:exec target from k where source=s;raze .z.s[k]each t;0#`]}
sources:{[k;t]t,$[count s:exec source from k where target=t;raze .z.s[k]each s;0#`]}
tree:{[k;s]distinct reverse[raze sources[k;s]],1_raze targets[k;s]}
targets_:{[k]distinct exec target from k}
sources_:{[k]distinct exec source from k}

/ selection
setselection:{[u;k;s]count[k]!@[0!u;`s_;:;$[(0=count s)|0=count k;count[u]#0;0+flip[value?[u;();();k!k]]in s]]}

/ selected operation
getselected:{[V;Z;X;Y;U;r]
 k:keys U;s:Z[Y`tab]`selected;
 $[V[`e_]r;
   [d:V[r]k;$[V[`s_]r;s:s where not all each s in d;s,:enlist d]];
   [n:unna_ V[`n_]r;g:count[n]#Z[Y`tab]`groups;d:flip value?[U;{(=;x;enlist y)}'[g;n];();k!k];$[V[`s_]r;s:s where not all each s in d;s,:d]]];
 s}

/ hierarchy
hierarchy:{[W_;r]hierarchy_[r]. W_[0]`s_`e_`i_}
hierarchy_:{[r;s;e;i]j:not[e]&s=i;k:not[e]&(s>0)&s<i;@[@[@[count[r]#-1;where e[r]&s r;:;1];where j r;:;1];where k r;:;0]}

/ required columns
required:{[R;z;x;v;g;a]
 m:cols v;
 o:z`columns;
 o:distinct g,R,o inter m;
 o:distinct o,distinct[raze x[`willbes]descendents/:o]inter m;
 o:distinct o,distinct[raze x[`rollups]descendents/:o]inter m;
 o:distinct o,distinct[raze x[`transforms]descendents/:o]inter m;
 o:distinct o,distinct[raze refs each a o]inter m;
 o:distinct o,`i_`s_;
 o}

/ children of 
descendents:{[d;w]w,$[0=count d;();0=count c:children[d;w]except w;();raze .z.s[d]each c]}
children:{[d;w]$[0=count d;(),w;key[d]inter refs wparse d w]}

/ system columns
Systemcolumns:`h_`l_`p_`e_`o_`n_`i_`s_`m_`g_`k_!(`;0;0;0b;1b;0#`;0;0;0#`;`;0)

/ redefine underlying table (U)
redefine:{[X;Y;Z]restrict[X;Y;Z]define[get table[Y]Z;X;Y]Z}

/ partitioned willbe definition
define:{[v;X;Y;Z]x:X table[Y]Z;define_[hide[v]x`hide;x`willbes]partitioned[Z;x`partitioned]Y`tab}
partitioned:{[Z;p;t]$[count p;first each@[flip enlist p;where p;:[;enlist Z[t]`groups]];0b]}

/ hide = fill columns with nulls
hide:{[t;h]$[count k:h where h in cols t;![t;();0b;k!(first 0#;)each k];t]}

/ willbe definition
define_:{[v;c;g]
 if[not count k:key c;:v];			/ exit if no willbe fields
 d:value[c]except\:"\r\n\t";			/ definitions
 p:k!wparse each d;				/ parse 
 if[0b~g;g:k!count[k]#0b];			/ no partitions
 h:where not 0b~'g;				/ partitioned
 i:@[p;h;(;);g h];				/ add partitions for ordering
 o:order refs each i;				/ ordered by reference
 o@:where o in k;				/ eliminate "value errors"
 willbes[v;o!p o;o!g o]}			/ create view

wparse:{$[0=count x;();parse{(neg(reverse x="\n")?0b)_x}x]}
willbes:{willbe/[x;key y;value y;value z]}
willbe:{[t;k;f;g]$[0~r:.[!;(t;();$[g~0b;g;g!g];enlist[k]!enlist f);0];![t;();0b;enlist[k]!enlist(#;count t;(::))];r]}
flatten:distinct raze over
ref:{$[-11=t:type x;x;t;();.z.s each x]}
refs:flatten ref@
order:{flatten[reverse(flatten x@)scan key x]inter key x}

/ first/last n records in nodes
setranks:{[t;a;u]
 if[0=count t;:t];
 if[0=count u;:t];
 S:{t:0!z;keys[z]xkey t x t y};A:S[iasc abs@];D:S[idesc abs@];
 u:update dir:(xasc;xdesc;A;D)(`$("asc";"desc";"asc abs";"desc abs"))?dir from u;
 r:keys[t]xkey setrank[0!t;a;0!u;()];
 r}

setrank:{[t;a;u;w]
 if[not count u;:?[t;w;0b;()]];
 v:first u;u:1_u;
 c:v`col;s:v`sort;n:v`n;d:v`dir;
 r:?[t;w;enlist[c]!enlist c;enlist[s]!enlist a s];
 k:{x,enlist(=;y;enlist z)}[w;c]each(n&count r)#?[d[s]r;();();c];
 raze .z.s[t;a;u]each k}

/ parse rollups
parserollups:{[v;r]@[wparse each defaultrollups[r;v];`i_`s_;:;((sum;`i_);(sum;`s_))]}
Defaultrollup:`Sum
defaultrollups:{[a;u]c:cols u;f:c except key a:nonempty a;a[f]:f{$[isnumber z;string[x]," ";"sym "],string y}[Defaultrollup]'(0!u)[0;f];a}
nonempty:{(where 0<count each x)#x}

/ set k_
setlevels:{[r]l:exec l_ from r;k:count[l]#0;i:0;do[1+max l;k[j]:raze(til count@)each where[1b,1_1<>deltas j]_j:where l=i;i+:1];update k_:k from r}

/ grouping columns (h_) preprend {n} based on .sorts (s) and level (l_) ~ groups (g)
setsorts:{[r;g;s]if[count h:g inter key s;l:r`l_;m:1+g?h;k:sorts[l]/[r`h_;s h;m];r[`h_]:k];r}
sorts:{[l;k;s;m]@[k;i;:;`${$["{"=first x;x;"{",y,"}",x]}'[string t;string s?t:k i:where l=m]]}

/ add m_, g_, apply transform functions
transform:{[r;g;t]
 if[0=count t:key[t]inter cols r;r[`m_`g_]:count[r]#'(enlist 0#`;`);:r];
 b:last each a:@[l#\:g;where count[g]<l:exec l_ from r;:[;enlist`$"."]];
 r:![r;();0b;`m_`g_!(enlist(),/:a;enlist b)];
 ![r;();0b;parse each t]}

/ symbolize for grouping
symbolize:{[d;g]if[count c:g inter exec c from meta d where t in"bhijemdzvut";k:keys d;d:0!d;d[c]:`$string d c;d:k xkey d];d}

/ predicates
isnumber:{type[x]in neg 1 5 6 7 8 9h}
issymbols:{type[x]in 11 20h}
isfunction:{99<type x}
isatom:{(0>type x)|isfunction x}

/ sort
sort:{[v;g;b;s;m]$[b&count s;v sorttable[g;v;m;key s;get s];v]}

sorttable:{[g;v;m;c;o]
 if[(0=count c)|2>n:count v;:til n];
 if[`h_ in c;v:update h_:` from v where e_];
 if[`h_~first -1_c;c:`h__,1_c;v:update h__:?[l_>1;`;h_]from v];
 n:reverse exec i by n from s:sortdata[g;v;m;c;o]where n>0;
 0,raze$[1=count n;s[`j]n;merge[s;g]/[();key n;get n]]}

sortcol:{[c;o;m]r:@[flip(@;abs;c;c);i;:;c i:where o in`a`d];r{$[count y;(y!til count y;x);x]}'m c}
sortrow:{[v;c;o]{x y z x}/[til count v;reverse o;?[v;();();enlist,reverse get c]]}
sortexpr:{$[1=count x;first x;(flip;(!;enlist key x;enlist,get x))]}

sortdata:{[g;v;m;c;o]
 a:!/[g,/:(`j`n;`i`l_)];
 c:c!sortcol[c;o;m];
 s:1=count distinct o:(<:;>:)o in`d`D;
 $[s;?[v;();0b;a;0W;(first o;sortexpr c)];?[v;();0b;a]sortrow[v;c;o]]}

level:{[s;g;n;i]c:((m:n&count g)#g),`j; (delete j from t)!flip enlist(t:(c#s)i)`j}
merge:{[s;g;x;n;i]v:level[s;g;n;i]; $[count x; @[v;(keys v)#key x;,;get x]; v]}

/ drill to (i>=1):  i = row, t in g = drill to group - z,v,u = attributes, treetable, underlying
drillto:{[z;v;u;i;t]
 n:v[`n_]i;
 g:z`groups;
 r:$[t in count[n]#g;drillto_up;drillto_down][z;v;u;t;n;g];
 z[`paths]:r;
 z}

drillto_up:{[z;v;u;t;n;g]
 p:z`paths;
 k:first value flip key p;
 h:(1+g?t)#g;
 s:h!count[h]#n;
 j:where not value[s]~/:k@\:key s;
 1!(0!p)j}

drillto_down:{[z;v;u;t;n;g]
 q:opento_[z;v;u;t;g];
 k:first value flip key q;
 s:(count[n]#g)!n;
 j:k where value[s]~/:k@\:key s;
 m:([n:j]v:count[j]#1b);
 p:z`paths;
 p,m}

/ open to group
opento:{[z;v;u;t]if[count g:z`groups;z[`paths]:opento_[z;v;u;t;g]];z}
opento_:{[z;v;u;t;g]h:(1+til count h)#\:h:(g?t)#g;m:distinct enlist[(0#`)!0#`],raze path[u]each h;([n:m]v:count[m]#1b)}
path:{enlist[(0#`)!0#`],y!/:NA^{@[x;where not issymbols each x;`$string@]}distinct flip value?[x;();();y!y]}
open:{[z;v;u]opento[z;v;u;`]}
autoexpandto:{[l;z;v;u]opento[collapse[z;v;u];v;u;{y x&-1+count y}[l]z`groups]}
autoexpand:autoexpandto Expandto
expandto:{[l;z;v;u]$[opened[z;v;u];opento[z;v;u;{y x&-1+count y}[l]z`groups];open[z;v;u]]}
expand:expandto 0W
collapse:{[z;v;u]opento[z;v;u;first z`groups]}
opened:{[z;v;u]$[0<count z`groups;count[u]=sum -6=type each exec h_ from v;0b]}
expand1:{[z;v;u]m:1+maxopened v;g:z`groups;if[m<count g;z:opento[z;v;u;g m]];z}
collapse1:{[z;v;u]m:-1+maxopened v;g:z`groups;if[m>=0;z:opento[z;v;u;g m]];z}
maxopened:{[v]max count each v[`n_]where v`o_}
expand_all:{[z;v;u]opento[z;v;u;`]}

/ NA
NA:`$"N/A"
unna:{@[x;where x=NA;:;`]}
unna_:{.[@;(x;where x~'NA;:;`);x]}
na:{$[issymbols x;NA^x;count[x]#NA]}

/ nodes, roots, leaves
nodecol:{[m;g]
 `h_`e_`n_`l_ ! $[m=0; (`;      0b; 0#$[count g;`;0];     0      );  / root
                  m=1; (last g; 0b; (flip;enlist,g);      count g);  / node
                       (`i;     1b; (flip;enlist,g,`i); 1+count g)]} / leaf

root:{[t;g;a]g xcols flip enlist each nodecalc[t;();();a;g],nodecol[0;g]}
node:{[t;w;g;a;k]b:k,first c:g except k;![nodecalc[t;w;b!b;a;1_c];();0b;nodecol[1;b]]}
leaf:{[t;w;g;a;k]?[t;w;0b;({x!x}g union key a),nodecol[2;g]]}
nodes:{[t;g;a;k;p]w:find[t;k;p];g xcols(node;leaf)[g~k][t;w;g;a;k]}
steps:{[t;g;a;p]raze nodes[0!t;g;a]'[key q;get q:p group key each p]}
findp:{[t;p]@[count[t]#0b;raze?[t;;();`i]'[{flip(=;key x;flip enlist get x)}each p];:;1b]}
find:{[t;k;p]$[0=count k;();all b:$[not[type p]|30>count p;findp[t;p];(k#t)in p];();enlist b]}
nodecalc:{[t;w;b;a;n]k:functionmap each$[99h=type b;n,key b;n]_a;N_::n;r:?[t;w;b;k];nodenull[t;n;r]}
nodenull:{[t;n;r]v:t[n][;0N];$[98h=type key r;@[0!r;n;:;v];r,n!v]}

/ map syms to vals for funs
functionmap:{m:.qq.F;$[0>type x;x;-11h=type f:first x;$[f in key m;@[x;0;:;m f];x];x]} 

/ drill up, down, roll
drillup:{[r;p]n:-1_'exec n_ from r;q:get each p;parent delete from r where n in q}
rollups:{[t;g;a;p;r;q]roll[t;g;a;();used p]}
drill:{[t;g;a;p;r;q]n:used p;o:used q;$[count[n]>count o;roll[t;g;a;r;n except o];drillup[r;o except n]]}
used:{exec n from x where min'[v{x\'[til count x]}n?-1_'n]}
parent:{update o_:i in p_ from update p_:n_ ? -1_'n_ from x}

/ rollup - t:input table, g:grp cols, a:rollups, r:prev, p:paths
roll:{[t;g;a;r;p]
 u:@[0!t;g;na];
 b:cols[u]#a;
 m:steps[u;g;b;p];
 n:$[r~();cols[m]xcols root[u;g;b];cols[m]#r];
 parent g xasc n,m}

\

/ build just the treetable = Z V
treetable_:{[F;X;Y;Z;U;V]
 q:xyz[X;Y]Z;x:q 0;z:q 1;
 G_::g:z`groups;N_::0#`;
 v:0!setselection[U;keys U]z`selected;
 v:filter[v]. z`filters`filtering`filters_not`filters_or;
 a:parserollups[v]x`rollups;
 v:setranks[v;a]z`ranks;
 v:symbolize[v]g;
 v:update i_:1 from v;
 v:?[v;();0b;r!r:required[z;x;v;g]a];
 v:F[v;g;a;z`paths;V]z`paths_;
 z[`paths_]:z`paths;
 v:setsorts[v;g]x`sortseqs;
 v:setlevels v;
 v:transform[v;g]x`transforms;
 v:sort[v;g]. z[`sorting`sorts],x 1#`sortseqs;
 Z[Y`tab]:z;
 (Z;v)}
