/ input log, no result log
J:hsym`$LOGS,"/t1.start.",string[INSTANCE],".j";J set();

/ register with SHM
.Z.hregister[PORT;`t1.start]

/ where the applications live
PATH:.u.t1_[]

/ block auto-exit
EXIT:0b

/ clear ramdisk
RAM:"/export/home/kdb/ramdisks/rd0"
system"rm -rf ",RAM,"/*";

/ keep track of application and gui processes
Apps:([app:0#`]state:0#0;port:0#0;who:0#0;z:0#0Nz)
Guis:([gui:0#0]state:0#0;login_:0#`;login:0#`;app:0#`;app_:0#`;layout:0#`;port:0#0;who:0#0;z:0#0Nz)
Node:([gui:0#0]who:0#0;id:0#`)

/ quit gui
quitgui:{zapgui .Z.w}
zapgui:{[w]delgui w;async[w]"exit 0"}
delgui:{[w]delete from`Guis where who=w}

/ screen
screen:{[s;c;q]system screenpl[],"screen -c ",screenrc[s]," -L -d -m -t ",s," -S ",s," ",getenv[`RLWRAP]," q ",string[q],".q ",c," &"}
screenrc:{[s]l:"/tmp/",s,"rc";hsym[`$l]0:"\n"vs ssr["logfile /tmp/$.log\nlogfile flush 1";"$";s];l}
screenpl:{$[SHM;"LD_PRELOAD=",getenv[`QPRELOAD]," ";""]}

/ build applications
start:{if[not REBUILD;startapp each string raze app each string key hsym`$PATH]}
app:{[a]$[a like"*_";();`app.q in key hsym`$"/"sv(PATH;a);`$a;()]}

/ restart gui server
restartgui:{[w]$[TRAP;exec restartgui_'[gui;login_;login;app;app_;layout;port]from Guis where who=w;delete from`Guis where who=w]}
restartgui_:{[g;l_;l;a;a_;b;p]run_["";string l_;string l;string[a],$[null a_;"";"-",string[a_],"[",string[b],"]"];g;p]0N}

/ restart app server
restartapp:{[w]a:first exec app from Apps where who=w;delete from`Apps where who=w;startapp string a}

/ start an app server
startapp:{[A]screen["t1.",string[INSTANCE],".",A;appargs A]`app;Apps[`$A;`state`port`who]:0N}

appargs:{[A]
 .u.rs("-sAPP"		;A;
       "-*PATH"		;PATH,"/",A;
       "-*LOGS"		;LOGS;
       "-bTRAP"		;TRAP;
       "-bMEM"		;MEM;
       "-bEXIT"		;0b;
       "-bSHM"		;SHM;
       "-*RAM"		;RAM;
       "-iZPORT"	;"";
       "-sSYSTEM"	;SYSTEM;
       "-sREGION"	;REGION;
       "-sHOST"		;HOST;
       "-iINSTANCE"	;INSTANCE;
       "-iPORT"		;PORT)}

/ register, running, reconnect, rebuild
regapp:{[a;p]Apps[a;`state`port`who`z]:(0;p;.Z.w;zz[])}
runapp:{[a]Apps[a;`state]:1;runpool a;recapp[.Z.w]a}
recapp:{[w;a]if[0<count p:exec port from Guis where state>0,gui>0,app=a;async[w](`recapp;p)]}
rebapp:{[a;p]Apps[a;`port`who`z]:(p;.Z.w;zz[])}

/ register, rebuild gui
reggui:{[g;l_;l;a;a_;b;p]if[g in key Guis;Guis[g;`state`login_`login`app`app_`layout`port`who`z]:(0;l_;l;a;a_;b;p;.Z.w;zz[])];runpool a}
rebgui:{[g;l_;l;a;a_;b;p]Guis[g;`state`login_`login`app`app_`layout`port`who`z]:(3 1 null l;l_;l;a;a_;b;p;.Z.w;zz[]);if[g<0;setnode[g;0N]`]}

/ create a pool of servers
runpool:{[a]if[POOL>numpool a;exepool string a]}
chkpool:{[a]if[POOLMIN=numpool a;exepool string a]}
exepool:{[a]run_["";"";"";a;0N;0N]0N}
numpool:{[a]count select from Guis where null login,app=a}

/ delete pooled guis
delguis:{[a]delete from`Guis where app=a;}

/ exe gui
gui:{[a;k;p]
 if[k in key Guis;if[k>0;if[Guis[k;`state]<a;Guis[k;`state]:a;
  if[a=2;if[null p;ws[Node[k;`who]]`id`fn`host`port!(string Node[k;`id];`run;.z.h;Guis[k;`port])]]]];
  if[a=3;if[not null p;async[.Z.w](`zport;p);Guis[k;`port]:p];delnode k]];
 }

appgui:gui 1	/ 1 = has data
rungui:gui 2	/ 2 = has object
congui:gui 3	/ 3 = has ws connection

/ set *unique* node handle
setnode:{[g;w;I]
 if[not null w;if[w in exec who from Node;zapnode each exec gui from Node where who=w]];
 Node[g;`who`id]:(w;`$I);
 }

/ zap gui, delete from node
zapnode:{[g]zapgui Guis[g;`who];delnode g}
delnode:{[g]delete from`Node where gui=g}

/ use a gui server from the pool
use:{[I;L_;L;O;A;A_;B;w]
 g:min exec gui from Guis where app=`$A,null login,not null who,state>0;
 if[g=0W;:.t.A[.t.add 1;(.z.s;I;L_;L;O;A;A_;B;w)]];
 Guis[g;`login_`login`app`app_`layout]:v:`$(L_;L;A;A_;B);
 setnode[g;w]I;
 async[Guis[g;`who]](`use;g),v;
 chkpool`$A;
 }

/ start a gui server
run:{[I;L_;L;O]run_[I;;;;0N;0N;.Z.w].(L_;L;runtrans O)}
run_:{[I;L_;L;O;g;p;w]
 q:runparts O;a:`$A:q 0;A_:q 1;B:q 2;
 if[a in key Apps;
  if[1>Apps[a;`state];:.t.A[.t.add 1;(.z.s;I;L_;L;O;g;p;w)]];
  if[POOL;if[numpool a;if[count I;:use[I;L_;L;O;A;A_;B]w]]]];
 if[null g;g:1+max 0,exec gui from Guis];
 Guis[g;`state]:0;
 if[not null w;setnode[g;w]I];
 c:guiargs[L_;L;A;A_;B;g]p;
 s:"t1.","."sv(string INSTANCE;L;string g;A);
 screen[s;c]`gui;
 }

runtrans:{[O]O}

runparts:{[O]
 k:string exec app from Apps;
 A:k(O like/:k,'"*")?1b;
 A_:("-"=first t)_t:count[A]_O;
 B:LAYOUT;
 if[count A_;if[count[A_]>i:A_?"[";B:1_-1_i _ A_;A_:i#A_]];
 (A;A_;B)}

guiargs:{[L_;L;A;A_;B;g;p]
 .u.rs("-bEXIT"		;1b;
       "-*RAM"		;RAM;
       "-sLOGIN_"	;L_;
       "-sLOGIN"	;L;
       "-bSHM"		;SHM;
       "-sAPP"		;A;
       "-sAPP_"		;A_;
       "-sLAYOUT"	;B;
       "-*PATH"		;PATH,"/",A;
       "-*LOGS"		;LOGS;
       "-sSYSTEM"	;SYSTEM;
       "-sREGION"	;REGION;
       "-bTRAP"		;TRAP;
       "-bMEM"		;MEM;
       "-bLOG"		;LOG;
       "-iINSTANCE"	;INSTANCE;
       "-iGUI"		;abs g;
       "-iPORT"		;PORT;
       "-iAPORT"	;Apps[`$A;`port];
       "-iZPORT"	;p)}

/ close app, gui
.z.pc:{[f;w]closeapp w;closegui w;f w;}.z.pc
closeapp:{[w]if[w in exec who from Apps;unreg[w]`Apps;restartapp w]}
closegui:{[w]if[w in exec who from Guis;unreg[w]`Guis;restartgui w]}

/ unregister port of closed server
unreg:{[w;v].Z.hunregister first?[v;enlist(=;`who;w);();`port]}

/ run it
start[]

\

t1/scripts/t1.sh -v t1 --start
t1/scripts/t1.sh -v t1 --rebuild 1 --start

http://10.5.7.185:8010/app/index.html#/bypass?operator=sapter&user=sapter&pwd=??????????&app=Holdings-desk
http://10.5.105.115:8010/app/index.html

user+password OR user#asuser+password
Login as kdbdev on ny-lxdesk115

>cd node/PNLMobile
>stop-gen3
>start-gen3

