.z.pc:{[f;w]
 if[w in exec who from Sub;.ps.reconnect w];			/ if publisher disconnects
 if[w in exec who from Pub;delete from`Pub where who=w];	/ if subscriber disconnects
 f w;}.z.pc

/ publishers, callback functions, subscribers
Sub:([host:0#`;server:0#`;ptable:0#`;table:0#`]ram:0#0b;method:0#`;n:0#0;pubz:0#0Nz;subz:0#0Nz;elapsed:0#0Nt,bytes:0#0,port:0#0;who:0#0)
Fun:()!()
Pub:([table:0#`;who:0#0]n:0#0)
Mem:update z:zz[]from enlist .Q.w[]
Rec:([]app:0#`;table:0#`;n:0#0;pubz:0#0Nz;recz:0#0Nz;elapsed:0#0Nt;bytes:0#0)

/ default host, app, init, and receive callbacks
subscribe:{[s].ps.subscribe[HOST;APP;s;{}]{}}

/ default dynamic columns
.ps.subscribe:{[h;a;s;I;R]Sub::.ps.default[h]s;Fun::`I`R!(I;R);$[null h;.ps.staticdata[s]I;.ps.connect a];}
.ps.default:{[h;t]keys[Sub]xkey update host:h,n:-1,pubz:0Nz,subz:0Nz,elapsed:0Nt,port:PORTS[flip enlist exec server from t;`port],who:0N from([]ptable:t`table;ram:0b;method:`)^t}

/ host change:  close connections, subscribe
.ps.resubscribe:{[o;n]w:distinct exec who from Sub where host=o;update host:n from`Sub where host=o;.Z.hclose each w;.ps.reconnect each w;}

/ static data (testing & development)
.ps.staticdata:{[s;I].ps.staticdata_[PATH]each exec table from s;.ps.apply[I]zz[]}
.ps.staticdata_:{[p;t]t set{$[.ps.iskeytable x;update DELETE:0b from x;x]}get hsym`$p,"/static/",string t;}

/ reconnect if p5 server disconnects
.ps.reconnect:{[w]update n:-1,pubz:0Nz,subz:0Nz,who:0N from`Sub where who=w;.ps.connect APP}

/ connect to server and retry
.ps.connect:{[a]if[any null exec who from Sub;update who:.ps.connect_[a;first host;first server;first port;ptable;table;method]by host,server,port from`Sub where null who;.t.A[.t.add 10](.z.s;a)]}

/ try to connect to server
.ps.connect_:{[a;h;s;p;t;u;m]if[not null w:.Z.hopen(.u.hpt(h;p);5000);.ps.publish[a;w]'[t;u;m]];w}

/ inject publication function
.ps.unpublish:{[a]update who:0N from`Sub where who=.Z.w;.t.A[.t.add 10](`.ps.connect;a)}
.ps.publish:{[a;w;t;u;m]async[w](.ps.publish_;a;t;u;m;.z.h;system"p")}
.ps.publish_:{[a;t;u;m;h;p]
 if[not .ps.Ready;:async[.Z.w](`.ps.unpublish;a)];
 q:.ps.initial[t;0b;`;a];
 k:iskeytable q 0;
 if[k;q:{![x;();0b;(1#`DELETE)!1#0b]}each q;b:getattr get t];
 Pub,:(a;h;t;0j;.z.z);
 Who,:(a;h;p;.Z.w);
 if[not null m;Act[t]:m,t];
 async[.Z.w]({.ps.tableof[.Z.w;x]set y};t;q 0);
 {async[x]({.ps.tableof[.Z.w;x]upsert y}y;z)}[.Z.w;t]each 1_q;
 async[.Z.w](`.ps.initpub;.z.z;t;$[k;b;()]);
 }

/ injected function and callback
.ps.getport:{[a;s]async[.Z.w](`.ps.setport;a;s;Reg[s;`port])}
.ps.setport:{[a;s;p]if[not null p;update port:p from`Sub where host=HOST,server=s,null port]}

/ logging
.ps.pr:{[s;t;z;e;d]pr[s,string t;(z;e;count d)]`}
.ps.pm:{-1"++memory:",raze string[k]{x,"[",y,"]"}'string x k:`used`heap`peak;x}

/ chunking logic
.ps.Chunk:ceiling .75*0W
.ps.chunks:{[v]$[(0=count v)|not type[v]in 98 99h;enlist v;count[keys v]!'.ps.chunk[0!v]cut 0!v]}
.ps.chunk:{[v]floor .ps.Chunk%count -8!get first v}

/ polyadic application
.ps.apply:{[f;a]if[not null f;.u.apply[f]a]}

/ registration
.ps.register:{t:exec table from`Sub;`Pub upsert flip(t;.Z.w;-1);.ps.pubz[.Z.w]each t;.ps.regdat[.Z.w]t;}

/ keytable?
.ps.iskeytable:{$[not 99=type x;0b;98=type get x]}

/ replace Deltas with deltas
.ps.deltas:{[t;d;u]
 .ps.resattr t;
 if[count d;d:enlist update DELETE:1b from d;if[count u;d:d,enlist update DELETE:0b from raze key each u];u:u,d];
 if[count u@:where 0<count each u;t upsert'u];
 }

/ initialization
.ps.initpub:{[z;t;a].ps.pr["=>";t;z;0N]get t;v:.ps.tableof[.Z.w]t;.ps.putattr[a]t;.ps.subz[.Z.w;zz[];z]t;if[not any null exec subz from`Sub;.ps.apply[Fun`I]z];.ps.putdat[.Z.w]t}
.ps.putattr:{[a;t]if[count a;t set putattr[a]get t]}
.ps.getattr:{[t]$[.ps.iskeytable v:get t;getattr v;()]}
.ps.resattr:{[t]a:getattr v:get t;t set putattr[a]v}
.ps.putdat:{[w;t]if[count v:exec who from Pub where table=t;.ps.pubz[w]t;.ps.regdat[v]t]}
.ps.regdat:{[w;t].ps.setdat[w]each t;async[w](`registered;zz[];t)}
.ps.setdat:{[w;t]$[first exec ram from Sub where table=t;.ps.initram[w]t;.ps.initshm[w;t].ps.chunks get t].ps.getattr t}
.ps.initram:{[w;t;a].ps.ramset t;async[w](`.ps.ramget;APP;t;a)}
.ps.initshm:{[w;t;v;a]async[w]({x set y};t;v 0);{[w;t;v]async[w]({x upsert y};t;v)}[w;t]each 1_v;async[w](.ps.putattr;a;t)}

/ receive, apply, and relay deltas
.ps.receive:{[z;a;t;d;u].ps.subz[.Z.w;zz[]]'[z;t];.ps.recpub[.Z.w]'[z;a;t;d;u];.ps.recapp[.Z.w;z;a;t;d;u];}
.ps.recpub:{[w;z;a;t;d;u].ps.pr["->";t;z;et .ps.updz[w]t]u;if[0<count v:exec who from Pub where table=t;.ps.pubz[;t]each v;async[v](`receive;z;a;t;d;u)]}
.ps.recapp:{[w;z;a;t;d;u].ps.execute'[a;.ps.tableof[w]each t;d;u];.ps.apply[Fun`R](z;a;t;d;u);}
.ps.execute:{[a;t;d;u]z:zz[];a[t;d]u;.ps.pr["^^";t;z;0N]u;.ps.memz z}

/ p->s, timestamp
.ps.tableof:{[w;t]first exec table from Sub where ptable=t,who=w}
.ps.memz:{if[MEM;`Mem upsert update z:x from enlist .ps.pm .Q.w[]]}
.ps.subz:{[w;z;Z;t]update pubz:z,subz:Z,elapsed:.u.et[z]Z,n:n+1 from`Sub where ptable=t,who=w;}
.ps.pubz:{[w;t]update n:n+1 from`Pub where table=t,who=w;}
.ps.updz:{[w;t]first exec subz from`Sub where table=t,who=w}
.ps.recz:{[z;t;b]Z:zz[];Rec,:(APP;t;1+max exec n from Rec where app=APP,table=t;z;Z;.u.et[Z]z;b)}

/ ramdisk fns
.ps.ramget:{[s;t;a]while[`~r:.[{get .ps.ramfil[x]y};s,t;`];sleep 1];t set .ps.putattr[a]r;}
.ps.ramfil:{[s;t]hsym`$RAM,"/",string[s],"/",string t}
.ps.ramset:{[t].ps.ramfil[APP;t]set get t;}

